=== added directory 'plugin/slave/tests'
=== added directory 'plugin/slave/tests/r'
=== added file 'plugin/slave/tests/r/basic.result'
--- plugin/slave/tests/r/basic.result	1970-01-01 00:00:00 +0000
+++ plugin/slave/tests/r/basic.result	2011-03-09 20:04:11 +0000
@@ -0,0 +1,25 @@
+DROP TABLE IF EXISTS t1;
+Populating master server
+CREATE TABLE t1 (a int not null auto_increment, primary key(a));
+INSERT INTO t1 VALUES (),(),();
+SELECT * FROM t1;
+a
+1
+2
+3
+Connecting to slave...
+Using connection slave_con...
+Checking slave contents...
+SHOW CREATE TABLE t1;
+Table	Create Table
+t1	CREATE TABLE `t1` (
+  `a` INT NOT NULL AUTO_INCREMENT,
+  PRIMARY KEY (`a`)
+) ENGINE=InnoDB COLLATE = utf8_general_ci
+SELECT * FROM t1;
+a
+1
+2
+3
+Switching to default connection
+DROP TABLE t1;

=== added directory 'plugin/slave/tests/t'
=== added file 'plugin/slave/tests/t/basic.test'
--- plugin/slave/tests/t/basic.test	1970-01-01 00:00:00 +0000
+++ plugin/slave/tests/t/basic.test	2011-03-09 20:04:11 +0000
@@ -0,0 +1,31 @@
+--disable_warnings
+DROP TABLE IF EXISTS t1;
+--enable_warnings
+
+--echo Populating master server
+
+CREATE TABLE t1 (a int not null auto_increment, primary key(a));
+INSERT INTO t1 VALUES (),(),();
+SELECT * FROM t1;
+
+--echo Connecting to slave...
+connect (slave_con,127.0.0.1,root,,test, $TESTBOT0_SERVER1);
+echo Using connection slave_con...;
+connection slave_con;
+--echo Checking slave contents...
+--source include/wait_for_slave_plugin_to_sync.inc
+#use sys_replication;
+
+#select * from applier_state;
+#select * from io_state;
+#select * from queue;
+#use test;
+SHOW CREATE TABLE t1;
+SELECT * FROM t1;
+
+--echo Switching to default connection
+connection default;
+disconnect slave_con;
+
+# cleanup
+DROP TABLE t1;

=== added file 'plugin/slave/tests/t/master.cnf'
--- plugin/slave/tests/t/master.cnf	1970-01-01 00:00:00 +0000
+++ plugin/slave/tests/t/master.cnf	2011-03-09 20:04:11 +0000
@@ -0,0 +1,2 @@
+[test_servers]
+servers = [[--innodb.replication-log],[--plugin-add=slave --slave.config-file=$MASTER_SERVER_SLAVE_CONFIG]]

=== added file 'tests/include/wait_for_slave_plugin_to_sync.inc'
--- tests/include/wait_for_slave_plugin_to_sync.inc	1970-01-01 00:00:00 +0000
+++ tests/include/wait_for_slave_plugin_to_sync.inc	2011-03-09 20:04:11 +0000
@@ -0,0 +1,39 @@
+###################################################
+# Author: pcrews
+# Date: 2011-03.09
+# Purpose: To wait until the master and slave have
+#         sync'ed - we do this by comparing the 
+#         max applied id on the slave to the max
+#         logged id on the master
+#
+# Requirements: we expect the master on default conn
+#               slave on slave_con
+# Details:
+#      1) Fill in and setup variables
+#      2) loop through looking for both
+#         io and sql threads to start
+#      3) If loops too long die.
+####################################################
+let $row_number= 1;
+let $run= 1;
+let $counter= 500;
+
+while ($run)
+{
+  connection slave_con ;
+  let $slave_max_id = query_get_value("SELECT last_applied_commit_id from sys_replication.applier_state", last_applied_commit_id, $row_number);
+  connection default ;
+  let $master_max_id = query_get_value("SELECT MAX(commit_id) from DATA_DICTIONARY.SYS_REPLICATION_LOG", MAX(commit_id), $row_number);
+  if ($slave_max_id == $master_max_id)
+    {
+      let $run= 0;
+    }
+  sleep 0.1;
+  if (!$counter){
+    --echo "Failed while waiting for slave to sync with master"
+    exit;
+  }
+  dec $counter;
+}
+
+

=== modified file 'tests/lib/drizzle_test_run/dtr_test_management.py'
--- tests/lib/drizzle_test_run/dtr_test_management.py	2011-02-23 17:17:25 +0000
+++ tests/lib/drizzle_test_run/dtr_test_management.py	2011-03-09 20:04:11 +0000
@@ -31,6 +31,7 @@
 import os
 import re
 import sys
+from ConfigParser import RawConfigParser
 
 import lib.test_mgmt.test_management as test_management
 
@@ -65,7 +66,12 @@
         self.master_count = 1
         self.server_options = test_server_options
         # We will populate this in a better fashion later on
-        self.server_requirements=[self.server_options]
+        # as we allow .cnf files, we need to do a bit of
+        # messing about to make this work right
+        if self.server_options == [] or type(self.server_options[0]) is not list:
+            self.server_requirements=[self.server_options]
+        else:
+            self.server_requirements = self.server_options
         self.comment = comment
         self.master_sh = master_sh
         self.disable = disable
@@ -200,7 +206,8 @@
             master_sh = master_sh_path 
         else:
             master_sh = None
-        master_opt_path = test_path.replace('.test','-master.opt')
+        master_opt_path = test_path.replace('.test', '-master.opt')
+        config_file_path = test_path.replace('.test', '.cnf')
         test_server_options = test_server_options + self.process_opt_file(
                                                            master_opt_path)
         (disable, comment) = self.check_if_disabled(disabled_tests, test_name)
@@ -259,11 +266,21 @@
             that reside at the suite-level if they exist.
             Return a list of the options found
 
+            We also process .cnf files - this
+            is currently dbqp-only and is the proper
+            way to do things :P
+
         """
         found_options = []
         opt_files = ['t/master.opt','t/suite.opt']
         for opt_file in opt_files:
             found_options = found_options + self.process_opt_file(os.path.join(suite_dir,opt_file))
+        # We also process the suite-level .cnf file(s).  We override
+        # a master.opt file if we have a .cnf file.  There is no reason they
+        # should ever be used in conjunction and I am biased towards .cnf ; )
+        cnf_files = ['t/master.cnf']
+        for cnf_file in cnf_files:
+            found_options = self.process_cnf_file(os.path.join(suite_dir,cnf_file))
         return found_options
 
     def process_disabled_test_file(self, testdir):
@@ -342,6 +359,33 @@
         opt_file.close()
         return found_options
 
+    def process_cnf_file(self, cnf_file_path):
+        """ We extract meaningful information from a .cnf file
+            if it exists.  Currently limited to server allocation
+            needs
+
+        """
+
+        server_requirements = []
+        if os.path.exists(cnf_file_path):
+            config_reader = RawConfigParser()
+            config_reader.read(cnf_file_path)
+            server_requirements = self.process_server_reqs(config_reader.get('test_servers','servers'))
+        return server_requirements
+
+    def process_server_reqs(self,data_string):
+        """ We read in the list of lists as a string, so we need to 
+            handle this / break it down into proper chunks
+
+        """
+        server_reqs = []
+        # We expect to see a list of lists and throw away the 
+        # enclosing brackets
+        option_sets = data_string[1:-1].strip().split(',')
+        for option_set in option_sets:
+            server_reqs.append([option_set[1:-1].strip()])
+        return server_reqs
+
     def testlist_filter(self, testlist):
         """ Filter our list of testdir contents based on several 
             criteria.  This looks for user-specified test-cases

